#ifndef GNCACCOUNTMANAGER_H
#define GNCACCOUNTMANAGER_H
///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	GNCAccountManager.h
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Sat May 26 11:42:41 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "finlink.h"
#include "GNCAccountNode.h"

/**
 * This class understands the interaction between the internal formats
 * and the common formats for GNUCash.
 */

class GNCAccountManager : public AccountManager
{
public:
	GNCAccountManager(const std::string& uri) throw(FatalException);
	virtual ~GNCAccountManager();

	virtual AccountNode::iterator* accounts();
	virtual void addAccount(AccountNode *a);
	virtual void deleteAccount(AccountNode *);
	virtual void deleteAllAccounts();
	virtual std::string getUsage();
	virtual AccountNode* newNode();
	virtual void readAccounts() throw(FatalException);
	virtual void writeAccounts() throw(FatalException);
	virtual void addTransaction(TransactionNode* n);
	virtual TransactionNode* getTransaction(TransactionNode *);

protected:
	virtual AccountNode* getRoot() { return root; }

protected:
	Session			*sess;
	AccountGroup		*group;
	Account			**aclist;
	GNCAccountNode		*root;

	typedef list<TransactionNode*>	TransList;
	TransList		_transactions;

	ErrorTrace		trace;
};

#endif
