///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	GNCTransSplit.cpp
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Tue Jun  5 16:04:38 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "GNCTransSplit.h"

#define MATURITY_LEVEL	0

using namespace std;

string GNCTransSplit::getMemo()
{
	string s(xaccSplitGetMemo(_split));
	return s;
}

void GNCTransSplit::setMemo(const string& s)
{
	xaccSplitSetMemo(_split, s.c_str());
}

string GNCTransSplit::getAccount()
{
	Account *a = xaccSplitGetAccount(_split);
	char *s = xaccAccountGetFullName(a, ':');
//assert(strlen(s) != 0);
	string acc(s);
	free(s);
	string s2;

//cout << "acc = " << acc << endl;
	// substitute all the ':' with "::"
	string::iterator p;
	for(p = acc.begin(); p != acc.end(); ++p)
		{
		if(*p != ':')
			{
			s2 += *p;
			}
		else
			{
			s2 += "::";
			}
		}

//cout << "s2 = " << s2 << endl;
	return "::" + s2;
}

void GNCTransSplit::setAccount(const string& s)
{
	
//	string cname = s.substr(2);

//	AccountGroup *r = xaccGetAccountRoot(xaccSplitGetAccount(_split));
//	Account *n = xaccGetAccountFromFullName(r, cname.c_str(), "::");

//	_split->acc = n;

	cerr << "error:  unsupported operation: setAccount" << endl;
}

double GNCTransSplit::getValue()
{
	return xaccSplitGetValue(_split);
}

void GNCTransSplit::setValue(double d)
{
	xaccSplitSetValue(_split, d);
}

GNCTransSplit::GNCTransSplit()
	: _split(static_cast<Split*>(NULL)), _manage(true)
{
	_split = xaccMallocSplit();
}

GNCTransSplit::GNCTransSplit(Split *s)
	: _split(s), _manage(false)
{
}

GNCTransSplit::~GNCTransSplit()
{
	if(_split != static_cast<Split*>(NULL) && _manage)
		{
//		xaccSplitDestroy(_split);
		}
}

string GNCTransSplit::toString()
{
	char buf[1024];
	strstream s(buf, 1024);
	memset(buf, 0, 1024);

	s << "[" << getAccount() << "]";
	s << "[" << getValue() << "]";

	return s.str();
}
