#ifndef GNCTRANSSPLIT_H
#define GNCTRANSSPLIT_H
///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	GNCTransSplit.h
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Tue Jun  5 16:02:08 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "TransactionNode.h"
#include "gnucash.h"

/**
 * This class is a very bare-bones implementation of an adapter for
 * GNUCash splits to the "portable" splits.
 */

class GNCTransSplit : public TransSplit
{
public:	
	friend class GNCAccountNode;

	virtual std::string getMemo();
	virtual void setMemo(const std::string& s);
	virtual std::string getAccount();
	virtual void setAccount(const std::string& s);
	virtual double getValue();
	virtual void setValue(double d);

	virtual TransSplit* newInstance() { return new GNCTransSplit(); }
	virtual string toString();

	GNCTransSplit();
	GNCTransSplit(Split *s);
	virtual ~GNCTransSplit();

	Split* getGNCSplit() { return _split; }

protected:
	Split	*_split;
	bool	_manage;
};

#endif
