#ifndef GNCTRANSACTIONNODE_H
#define GNCTRANSACTIONNODE_H
///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	GNCTransactionNode.h
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Tue Jun  5 15:20:44 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "TransactionNode.h"
#include "gnucash.h"

/**
 * The GNUCash transaction adapter.  We're going to take a slightly
 * different tact than we did for the accounts.  The transactions are
 * going to be dynamically created/destroyed by the owner account.
 */

class GNCTransactionNode : public TransactionNode
{
	friend class GNCAccountNode;
public:
	virtual time_t getDate();
	virtual void setDate(time_t);
	virtual	std::string getNumber();
	virtual void setNumber(const std::string& s);
	virtual std::string getDescription();
	virtual void setDescription(const std::string& s);
	virtual TransSplit::iterator* splits();
	virtual void addSplit(TransSplit *s);
	virtual void removeSplit(TransSplit *s);
	virtual double getValue();
	virtual double getBalance();

	virtual TransactionNode* newInstance();
	virtual TransSplit* newSplit();

	virtual string toString();

	GNCTransactionNode();
	GNCTransactionNode(Transaction* t);
	GNCTransactionNode(Transaction* t, Account *a);
	virtual ~GNCTransactionNode();

protected:
	Transaction	*_trans;
	Account		*_acc;
	bool		_manage;
	ErrorTrace	trace;
};

#endif
