///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	finlink-gnucash.cpp
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Tue Jun  5 09:32:48 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "gnucash.h"
#include "GNCAccountManager.h"
#include "ManagerCreator.h"

using namespace std;

typedef GenericManagerCreator<GNCAccountManager>	ManagerType;

static auto_ptr<ManagerType> ap;

/**
 * This function is used to register the conduit module for GNUCash.
 * The auto_ptr is responsible for freeing the instance when the
 * module is unloaded.
 */

void init_module(void)
{
	ap.reset(new ManagerType("gnucash"));
}
