#ifndef FATALEXCEPTION_H
#define FATALEXCEPTION_H
///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	FatalException.h
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Sat Jun  2 13:23:42 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "stdcxx.h"

/**
 * This class represents fatal application errors that cannot be
 * ignored.
 */

class FatalException
{
public:
	FatalException(const char *fmt, ...)
	{
		char buf[2048];
		va_list args;
		va_start(args, fmt);
		vsprintf(buf, fmt, args);
		va_end(args);

		_msg = buf;
	}

	std::string getMessage() const { return _msg; }

protected:
	std::string _msg;
};

#endif
