#ifndef PCACCOUNTMANAGER_H
#define PCACCOUNTMANAGER_H
///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	PCAccountManager.h
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Sat May 26 09:43:02 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "finlink.h"
#include "palmcoins.h"
#include "PCAccountNode.h"

/**
 * This class understands the interaction between the internal formats
 * and the common formats for PalmCoins.
 */

class PCAccountManager : public AccountManager
{
public:
	PCAccountManager(const std::string& s) throw(FatalException);
	virtual ~PCAccountManager();

	virtual std::string getUsage();
	virtual void readAccounts() throw(FatalException);
	virtual void writeAccounts() throw(FatalException);
	virtual AccountNode::iterator* accounts();

	static int bal_cvt(double d);
	static char* ACCOUNTS_DATABASE;
protected:
	DLP			*pilot;
	PalmCoinsAppInfo	app_info;
	int			accounts_db;

	typedef map<unsigned long, PCAccountNode*> 	node_map_t;
	node_map_t		node_map;
	PCAccountNode		*root;
};

#endif
