///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	ModuleLoader.cpp
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Tue Jun  5 09:57:17 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "ModuleLoader.h"
#include "ManagerCreator.h"

// FIXME:  remove when dynamic loading works
#include "GNCAccountManager.h"
//#include "PCAccountManager.h"
static GenericManagerCreator<GNCAccountManager> *ap_gnc;
//static GenericManagerCreator<PCAccountManager> *ap_pc;

ModuleLoader* ModuleLoader::_instance = static_cast<ModuleLoader*>(NULL);
auto_ptr<ModuleLoader> ModuleLoader::_del;

ModuleLoader* ModuleLoader::getInstance()
{
	if(_instance == static_cast<ModuleLoader*>(NULL))
		{
		_instance = new ModuleLoader();
		_del.reset(_instance);
		}

	return _instance;
}

ModuleLoader::~ModuleLoader()
{
	delete ap_gnc;
//	delete ap_pc;
}

/**
 * This is where we cheat.  In a perfect world, we'd look for the
 * files in the directory and load them, calling their init_module()
 * functions, but right now, we're using the brute-force method.
 */

void ModuleLoader::loadModules()
{
	ap_gnc = new GenericManagerCreator<GNCAccountManager>("gnucash");
//	ap_pc = new GenericManagerCreator<PCAccountManager>("palmcoins");
}

