///////////////////////////////////////////////////////////////////////
//
// This file is part of the finlink conduit for PalmCoins 
// Copyright (C) 2001 Andrew S. Townley 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA,
// 02111-1307  USA
//
// Name:	TransactionNode.cpp
// Author:	Andrew S. Townley <adz1092 at netscape dot net>
// Created:	Wed Jun  6 14:22:09 CDT 2001
//
///////////////////////////////////////////////////////////////////////

#include "TransactionNode.h"
#include "AccountManager.h"
#include "Balance.h"
#include "Format.h"

void TransactionNode::copy(TransactionNode *src, AccountManager *m)
{
	setDate(src->getDate());
	setNumber(src->getNumber());
	setDescription(src->getDescription());

	// copy the splits
	TransSplit::iterator_ptr p(src->splits());
	for(p->first(); p->moreElements(); p->next())
		{
		TransSplit *cs = p->current();
		TransSplit *ns = newSplit();
		// copy the contents of the split
		ns->copy(cs);
		
		// add the split to this transaction
		addSplit(ns);

		// add the split to the proper account
		AccountNode *target = m->getAccount(cs->getAccount());
		if(target != static_cast<AccountNode*>(NULL))
			{
			target->addSplit(ns);
			}
		}
}

bool TransactionNode::operator==(TransactionNode& rhs)
{
	if(getDescription() == rhs.getDescription() &&
			getDate() == rhs.getDate() &&
			getNumber() == rhs.getNumber())
//			getNumber() == rhs.getNumber() &&
//			abs(Balance::bal_cvt(getValue())) == abs(Balance::bal_cvt(rhs.getValue())))
		{
			return true;
		}

	return false;
}

