/**
    $Revision: 1.8 $
    Last updated: $Date: 2001/07/24 01:00:04 $

    Copyright (C) 2001 Vlad Mereuta <dizzy@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	 
    $Log: ChooseAccountForm.h,v $
    Revision 1.8  2001/07/24 01:00:04  chaese
    eliminated references to PalmCoins except in situations that require
    renaming CVS controlled files (or other instances that I've overlooked :)

    Revision 1.7  2001/07/16 02:15:57  chaese
    ChooseAccountForm now shows the whole list of accounts (rather than having
    the user navigate through the hierarchy levels) and preselects the current
    setting as specified by the caller.

    Revision 1.6  2001/07/09 02:29:39  chaese
    implement splits GUI & other small improvements along the way. The bulk of
    the splits GUI is complete, small data integrity checks are coming soon
    (need to prevent multiple splits for the same account within one transaction
    and stuff like that...)

    Revision 1.5  2001/07/01 03:31:42  chaese
    eliminated artifacts from old way of categorizing accounts

    Revision 1.4  2001/06/26 23:30:37  dizzy
    Forms are now classes rather then namespaces. This should enable future code optimisations

    Revision 1.3  2001/06/17 05:23:32  chaese
    *** CAUTION: DATABASE STRUCTURE HAS CHANGED YET AGAIN ***
    I generally don't like 'cross-logging', but too many changes have accumulated
    to keep them separated.
    1. completely eliminated account categories
    2. introduced currently unused type field in the account record structure
    (This will become what the user sees as 'category selector'. Coming soon!)
    3. completely eliminated protected accounts (mostly because #1 made it so much
    harder to locate the "Misc" account in the Expense category:) Those should be
    replaced with Pref. settings for default Income and Expense accounts anyway.
    4. changes to user interface; some as mere consequences of 1. (e.g.
    Account chooser), some for usability reasons (Transaction form).
    5. bugfixes and minor improvements.

    Revision 1.2  2001/05/14 17:15:55  dizzy
    Parent accounts display total in children accounts when collapsed
    The program displays a message while creating the sample accounts on startup
    Quick transaction button (together with default account selection)
    Can choose default cleared state for transactions
    Fixed bug 407185 (adding scheduled transactions)

    Revision 1.1  2001/04/25 21:12:36  dizzy
    initial cvs commit
*/

#ifndef __CHOOSE_ACCOUNT_FORM__
#define __CHOOSE_ACCOUNT_FORM__

#include <PalmOS.h>

#include "MiscFunc.h"
#include "Form.h"

#include "FreeCoinsRsc.h"

///the form is used to create a new transaction or to modify an existing one, depending on the record_is_new member
class ChooseAccountForm : public Form
{	
public:	
	static ChooseAccountForm* theForm;

	///if true the form will allow the user to click ok without making a selection (for selecting catogories and/or the account currently explored)
	Boolean allow_no_selection;
	
	///choosen account
	UInt32	chosen_account;
	///true if an account was chosen
	Boolean chosen;
	
	ChooseAccountForm() { allow_no_selection = false; }
			
	///set the values of various form fields from the database
	void	init() FORM_SECTION;

	///event handler for the form
	Boolean handleEvent(EventPtr event) FORM_SECTION;

	/// callback for custom list drawing
	static void drawAccountName(Int16 itemNum,
	    RectangleType *bounds, Char **txt) FORM_SECTION;

};

#endif
