/**	
	$Revision: 1.8 $
	Last updated: $Date: 2001/07/01 12:21:55 $
	
	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log: EditScheduledTransForm.h,v $
	Revision 1.8  2001/07/01 12:21:55  dizzy
	Merged ScheduledDB into TransactionsDB
	
	Revision 1.7  2001/06/27 22:58:11  dizzy
	Restructured #include directives
	
	Revision 1.6  2001/06/26 23:30:37  dizzy
	Forms are now classes rather then namespaces. This should enable future code optimisations
	
	Revision 1.5  2001/01/31 18:07:24  dizzy
	More updates to the scheduling code (still not working though :( )
	Moved all Form code in a separate code section
	
	Revision 1.4  2001/01/29 18:49:30  dizzy
	Put code for scheduled transactions in a separate code section to enable the linking process to succeed.
	Scheduled trans info can be add/deleted/updated
	Added cleared field to trans structure
	
	Revision 1.3  2001/01/27 17:05:45  dizzy
	Updates to the scheduled transactions form. Unfortunatelly there are some linking problems
	which prevent the program from compiling :-(.
	
	Revision 1.2  2001/01/26 18:44:38  dizzy
	The date is now changed/choosen by a selector trigger (as opposed to a button)
	Moved Cleared column on the rhs of the screen
	TODO renamed to todo.html
	Account details can be accessed from the transactions screen menu
	Tap on account name will now take the user to the transactions screen (there are some problems with account deletion :( )
	Tap on expected balance column will take the user to scheduled transactions list
	
	Revision 1.1  2001/01/23 20:40:11  dizzy
	Initial support for scheduled transactions.		
*/

#ifndef __EDIT_SCHEDULED_TRANS_FORM__
#define __EDIT_SCHEDULED_TRANS_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "TransactionsDB.h"
#include "MiscFunc.h"

/**
   the form is used to create a new scheduled transaction or to modify an existing one, depending on the record_is_new member
   \todo automatically update the scheduled list on exit
*/
class EditScheduledTransForm : public Form
{
 private:
	//.stores the choosen start date
	DateType	start_date;
   ///pointer received from the EditTransactionForm. should point to the date field of the current transaction
   DateType* trans_date;
         
   ///string holding the displayable text for start date
	Char		start_date_txt[dateStringLength];
   ///string holding the displayable text for end date
	Char		end_date_txt[dateStringLength];
		
	//the current data
	scheduledStructure* st;
	/// this is set to true if we want to create a new account and to false if we want the 'details' functionality
	Boolean record_is_new;
	
 public:
	
//	EditScheduledTransForm(EditTransactionForm* t) : edit_trans_form(t) {}
//	virtual ~EditScheduledTransForm() {}
	
   ///sets the value of the record_is_new attribute
	void setRecordIsNew(Boolean b) FORM_SECTION;
   
   /**
      Starts a new session. Receives a new pointer and sets the saved state to false. It also sets
      record_is_new to true
      @param s pointer to a scheduledStructure where data is to be written 
   */
   void newSession(scheduledStructure* s, DateType* trans_date) FORM_SECTION;
   
	///saves the transaction data and updates all the accounts involved
	Boolean save() FORM_SECTION;


	///set the values for some of the fields in the form (from the transaction record)
	void setDefaults() FORM_SECTION;

	/**
		sets the repetition interval for the transaction (both on-screen and in the structure
		@param interval new interval
	*/
	void setInterval(repeatInterval interval) FORM_SECTION;
			
	/// event handler for the form
	Boolean handleEvent(EventPtr event) FORM_SECTION;
};
#endif
