/**	
	$Revision: 1.1 $
	Last updated: $Date: 2001/07/09 02:29:39 $

	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
	$Log: EditSplitForm.h,v $
	Revision 1.1  2001/07/09 02:29:39  chaese
	implement splits GUI & other small improvements along the way. The bulk of
	the splits GUI is complete, small data integrity checks are coming soon
	(need to prevent multiple splits for the same account within one transaction
	and stuff like that...)
	

*/

#ifndef __EDIT_SPLIT_FORM__
#define __EDIT_SPLIT_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "MiscFunc.h"

class EditSplitForm : public Form
{	
 private:
	Char acc_name[50];
	Char debit_label[32];
	Char credit_label[32];
	UInt32 acc_uid;
	Int32 amount;
	Boolean is_debit;

	Boolean checkData(void) FORM_SECTION;

	void saveData(void) FORM_SECTION;

 public:

	UInt8 split_index;

	EditSplitForm() { }
 	virtual ~EditSplitForm () {}
	
	static EditSplitForm *theForm;

	static Boolean eventHandler(EventPtr event) FORM_SECTION;

	Boolean handleEvent(EventPtr event) FORM_SECTION;

};

#endif
