/**	
	$Revision: 1.1 $
	Last updated: $Date: 2001/06/27 01:26:09 $
	
	$Log: Form.h,v $
	Revision 1.1  2001/06/27 01:26:09  dizzy
	Initial commit
	

	Copyright (C) 2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#ifndef __FORM__
#define __FORM__

#include <PalmOS.h>

///Generic structure of a form
class Form
{	
	protected:
		///pointer to the form
		FormPtr	frm;
	
		///true if the form was saved, false otherwise
		Boolean saved;
	
		///the id of the caller form; can be use to enable returning to the correct caller after finishing	
		UInt16 caller_form_id;
		
		
	public:
		//constructor
		Form() : saved(false) {}
	
		///returns the saved attribute
		Boolean getSaved() { return saved; }
		
		///sets the saved attribute
		void 		setSaved(Boolean b) { saved = b; }

		///sets the caller id attribute		
		void		setCallerFormId(UInt16 t) { caller_form_id = t; }

	/**
		event handler for the form; this will have to be overloaded in every derived class
		@param EventPtr pointer to the incoming event
		@return true if event was handled, false othewise
	*/
	virtual Boolean	handleEvent(EventPtr)=0;
};
#endif
