/**	
	$Revision: 1.2 $
	Last updated: $Date: 2001/07/24 01:00:04 $
	
	Copyright (C) 2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log: PurgeTransForm.cpp,v $
	Revision 1.2  2001/07/24 01:00:04  chaese
	eliminated references to PalmCoins except in situations that require
	renaming CVS controlled files (or other instances that I've overlooked :)
	
	Revision 1.1  2001/07/15 11:38:12  dizzy
	Added interface for purging transactions
	
*/

#include "PurgeTransForm.h"
#include "FreeCoinsRsc.h"

Boolean PurgeTransForm::handleEvent(EventPtr event)
{
	Boolean 					handled = true;

	// Get the form pointer
	frm = FrmGetActiveForm();
		
	// Key Events
	switch(event->eType) {

	// Form Update
	case frmUpdateEvent:
      //update the date field (could have been changed by editscheduledtransform)
  		updateDateField(PURGE_TRANS_CHOOSE_DATE,date,date_txt);		
		if (!osVerGe(palmos_3_5)) FrmEraseForm(frm);
		FrmDrawForm(frm);
        break;
  	
	// Form Open
	case frmOpenEvent:		
		//draw form
		DateSecondsToDate(TimGetSeconds()-2592000,&date); //set default date one month in the past
  		updateDateField(PURGE_TRANS_CHOOSE_DATE,date,date_txt);		
		FrmDrawForm(frm);
		break;
	
	// Controls
	case ctlSelectEvent:
		switch( event->data.ctlSelect.controlID ) {
			case PURGE_TRANS_OK:
				//if something is wrong, an error message has already been
				//issued by checkData, so do nothing.
		        if (FrmCustomAlert(GENERIC_YES_NO,
			        "This will cause the transactions earlier than the given date to be deleted. Do you want to continue?",
			        NULL, NULL)==1) break;
                transactions_db->purgeTransactions(date);
				FrmReturnToForm(0);
				break;
			case PURGE_TRANS_CHOOSE_DATE:
				selectDate(date,PURGE_TRANS_CHOOSE_DATE,date_txt);
				break;
			case PURGE_TRANS_CANCEL:
				//cancel button was pressed;
				//simply return to the main form
				FrmReturnToForm(0);
				break;
		default:
			handled = false;
		};
		break;	
	// Everything else...
	default:
		handled = false;
	}	
	return handled;
}
