/**	
	$Revision: 1.3 $
	Last updated: $Date: 2001/07/15 11:38:12 $

	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
	$Log: SplitsForm.h,v $
	Revision 1.3  2001/07/15 11:38:12  dizzy
	Added interface for purging transactions
	
	Revision 1.2  2001/07/09 02:29:39  chaese
	implement splits GUI & other small improvements along the way. The bulk of
	the splits GUI is complete, small data integrity checks are coming soon
	(need to prevent multiple splits for the same account within one transaction
	and stuff like that...)
	
	Revision 1.1  2001/07/06 03:03:35  chaese
	First baby steps toward a GUI for split transactions. Viewing works,
	editing doesn't (yet).
	

*/

#ifndef __SPLITS_FORM__
#define __SPLITS_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "SplitsTable.h"
#include "MiscFunc.h"

class SplitsForm : public Form
{	
private:
	SplitsTable splits_tbl;

	UInt8 splits_count;
	MemHandle splits_data;

	UInt32 total_debits;
	UInt32 total_credits;

	Boolean checkIndex(UInt8 index) FORM_SECTION;

 public:
	SplitsForm() { splits_data = NULL;
			total_debits = total_credits = splits_count = 0; }
 	virtual ~SplitsForm () {}
	
	static SplitsForm *theForm;

	static Boolean eventHandler(EventPtr event) FORM_SECTION;

	/**
		Generic handler for the application's static form(s)
		@return true if the event was handled, false otherwise
	*/
	Boolean handleEvent(EventPtr event) FORM_SECTION;

	UInt16 getCount() FORM_SECTION;

	void setCount(UInt8 count) FORM_SECTION;

	UInt32 getAccount(UInt8 index) FORM_SECTION;

	void setAccount(UInt8 index, UInt32 acc_uid) FORM_SECTION;

	Int32 getAmount(UInt8 index) FORM_SECTION;

	void setAmount(UInt8 index, Int32 amount) FORM_SECTION;

	void deleteSplit(UInt8 index) FORM_SECTION;
};

#endif
