/**	
	$Revision: 1.3 $
	Last updated: $Date: 2001/06/30 03:45:41 $
	
	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log: Table.cpp,v $
	Revision 1.3  2001/06/30 03:45:41  chaese
	Reduced Table::showScrollArrows to be merely a wrapper around the OS
	function FrmUpdateScrollers.
	
	Revision 1.2  2001/06/27 22:58:11  dizzy
	Restructured #include directives
	
	Revision 1.1  2001/06/25 10:42:35  dizzy
	Change file extensions
	
	Revision 1.5  2000/12/13 12:09:38  dizzy
	Fixed bug which caused a crash each time a transaction was updated
	
	Revision 1.4  2000/12/12 00:17:28  dizzy
	Fixed a bug relate to displaying scroll arrows
	
	Revision 1.3  2000/12/11 16:27:25  dizzy
	C++ version of the code.	
*/

#include "Table.h"

#include "MiscFunc.h" //for getobjptr

void Table::setRowsUnusable(UInt16 start)
{
	for(UInt16 i=start;i<rows;i++)
		TblSetRowUsable(table,i,false);		
}

void Table::unhighlight()
{
	TblUnhighlightSelection(table);
}

Boolean Table::pageUp()
{
	if(top_visible_item) {
		if(top_visible_item>=rows) top_visible_item-=rows-1;
		else top_visible_item=0;
		return true;
	}	
	return false;
}

Boolean Table::pageDown()
{
	if(total_items>rows) {					
		if(top_visible_item+rows+1<total_items) top_visible_item+=rows-1;
		else top_visible_item=total_items-rows;
		return true;
	}
	return false;	
}

void Table::initTable()
{
	//init globals
	table=(TablePtr) GetObjectPtr(table_resource);
	ErrFatalDisplayIf(!table, "table is null!!!");

	//get max number of visible rows
	rows = TblGetNumberOfRows(table);	

	top_visible_item=0;
	loadData();
}

Table::Table(UInt32 table_resource, UInt32 up, UInt32 down)
{
	this->table_resource=table_resource;
	up_arrow=up;
	down_arrow=down;
}

Table::~Table()
{
}

void Table::hideScrollArrows()
{
	CtlSetEnabled((ControlPtr) GetObjectPtr(up_arrow),false);
	CtlSetEnabled((ControlPtr) GetObjectPtr(down_arrow),false);
	CtlHideControl((ControlPtr) GetObjectPtr(up_arrow));
	CtlHideControl((ControlPtr) GetObjectPtr(down_arrow));	
}

void Table::showScrollArrows()
{
    Boolean		enableUp = false, enableDown = false;
	FormPtr frm = FrmGetActiveForm();

    if ((total_items > rows) || top_visible_item) {
    	// first element is not 0, hence we can scroll up
        if (top_visible_item)
            enableUp = true;
        
		// enable scrolling down if there are enough elements
        if ((top_visible_item+rows) < total_items)
            enableDown = true;
    }
	FrmUpdateScrollers(frm, FrmGetObjectIndex(frm, up_arrow),
		FrmGetObjectIndex(frm, down_arrow), enableUp, enableDown);
}
