/**	
	$Revision: 1.9 $
	Last updated: $Date: 2001/06/27 22:58:11 $
	
	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log: TransactionsTable.h,v $
	Revision 1.9  2001/06/27 22:58:11  dizzy
	Restructured #include directives
	
	Revision 1.8  2001/01/26 18:44:38  dizzy
	The date is now changed/choosen by a selector trigger (as opposed to a button)
	Moved Cleared column on the rhs of the screen
	TODO renamed to todo.html
	Account details can be accessed from the transactions screen menu
	Tap on account name will now take the user to the transactions screen (there are some problems with account deletion :( )
	Tap on expected balance column will take the user to scheduled transactions list
	
	Revision 1.7  2000/12/13 16:37:34  dizzy
	Ability to display a column which indicates/modifies the cleared state for each transaction
		(it is on by default; it can be turned off from the preferences dialog)
	The default view in the transaction list can be selected from the preferences dialog
	
	Revision 1.6  2000/12/11 16:27:25  dizzy
	C++ version of the code.		
*/


#ifndef __TRANSACTIONS_TABLE__
#define __TRANSACTIONS_TABLE__

#include <PalmOS.h>

#include "Table.h"

class TransactionsTable : public Table 
{
  public:
	///name all the columns
	static const Int16	date_col=0;
	static const Int16	dest_col=1;
	static const Int16	amount_col=2;
	static const Int16	cleared_col=3;

	/// initialises the table
	TransactionsTable();

	///loads data into the accounts table
	void loadData();
	
	///inits the columns in the table
	void initColumns();
	
	///overloads the method in Table
	Boolean recordIsValid(UInt16 id);

	///draws a sum of money
	static void drawCurrency(void* table, Int16 row, Int16 column, RectangleType* bounds);

	///draws a date
	static void drawDate(void* table, Int16 row, Int16 column, RectangleType* bounds);

	///draw the account name (source or dest; the one which is different from the present account)
	static void drawAcc(void* table, Int16 row, Int16 column, RectangleType* bounds);
};

#endif
